<?php
class tx_fontsizer_eID {

	/**
	 * Takes care of storing the new font size and redirecting to the 
	 * desired url, or produces CSS output for a particular fontsize
	 *
	 * @return void
	 */
	public function main() {
			//initialise FE user
		$feUserObj = tslib_eidtools::initFeUser();
			//if size given, store and redirect
		$size = t3lib_div::_GET('size');
		if ($size) {
			$feUserObj->setKey('ses', 'tx_fontsizer_size', $size);
			$feUserObj->storeSessionData();
			$return = t3lib_div::_GET('redirect');
			$return = $this->validateRedirectUrl($return);
			if ($return !== '') {
				t3lib_utility_Http::redirect($return, t3lib_utility_Http::HTTP_STATUS_302);
			} else {
				throw new InvalidArgumentException('Redirect URL not valid', 1312664834);
			}
		} else {
				//if no params give, retrieve CSS and return it.
			$pid = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['fontsizer']);
			$pid = $pid['tsconfigpid'];
			$pid = intval($pid) > 0 ? intval($pid) : 1;
			$tsConf = t3lib_BEfunc::getPagesTSconfig($pid);
			$size = trim($feUserObj->getKey('ses', 'tx_fontsizer_size'));
			if (!$size) {
				$size = $tsConf['fontsizer.']['default'];
			}
			header('Content-type: text/css');
			echo $tsConf['fontsizer.'][$size];
		}
	}

	/**
	 * Returns a valid and XSS cleaned url for redirect, checked against current host
	 *
	 * Original from felogin
	 *
	 * @param string $url
	 * @return string cleaned url or empty string if not valid
	 */
	protected function validateRedirectUrl($url) {
		$url = strval($url);
		if ($url === '') {
			return '';
		}

		$decodedUrl = rawurldecode($url);
		$sanitizedUrl = t3lib_div::removeXSS($decodedUrl);

		if ($decodedUrl !== $sanitizedUrl || preg_match('#["<>\\\]+#', $url)) {
			t3lib_div::sysLog(sprintf('Possible XSS attack in redirect URL: "%s"', $url), 'fontsizer', t3lib_div::SYSLOG_SEVERITY_WARNING);
			return '';
		}

			// Validate the URL:
		if ($this->isRelativeUrl($url) || $this->isInCurrentDomain($url)) {
			return $url;
		}

			// URL is not allowed
		t3lib_div::sysLog(sprintf('Redirect URL "%s" is not allowed', $url), 'fontsizer', t3lib_div::SYSLOG_SEVERITY_WARNING);
		return '';
	}

	/**
	 * Determines whether the URL is on the current host and belongs to the current TYPO3 installation.
	 *
	 * Original from felogin
	 *
	 * @param string $url URL to be checked
	 * @return boolean Whether the URL belongs to the current TYPO3 installation
	 */
	protected function isInCurrentDomain($url) {
		return (t3lib_div::isOnCurrentHost($url) && t3lib_div::isFirstPartOfStr($url, t3lib_div::getIndpEnv('TYPO3_SITE_URL')));
	}

	/**
	 * Determines whether the URL is relative to the current TYPO3 installation.
	 *
	 * Original from felogin
	 *
	 * @param string $url URL which needs to be checked
	 * @return boolean Whether the URL is considered to be relative
	 */
	protected function isRelativeUrl($url) {
		$parsedUrl = @parse_url($url);
		if ($parsedUrl !== FALSE && !isset($parsedUrl['scheme']) && !isset($parsedUrl['host'])) {
				// If the relative URL starts with a slash, we need to check if it's within the current site path
			return (!t3lib_div::isFirstPartOfStr($parsedUrl['path'], '/') ||
					t3lib_div::isFirstPartOfStr($parsedUrl['path'], t3lib_div::getIndpEnv('TYPO3_SITE_PATH')));
		}
		return FALSE;
	}
}

if (defined('TYPO3_MODE') && $GLOBALS['TYPO3_CONF_VARS'][TYPO3_MODE]['XCLASS']['ext/fontsizer/class.tx_fontsizer_eid.php']) {
	include_once($GLOBALS['TYPO3_CONF_VARS'][TYPO3_MODE]['XCLASS']['ext/fontsizer/class.tx_fontsizer_eid.php']);
}

$OBE = t3lib_div::makeInstance('tx_fontsizer_eID');
$OBE->main();
?>