<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2010 Jigal van Hemert <jigal@xs4all.nl>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 * Hint: use extdeveval to insert/update function index above.
 */

require_once(PATH_tslib.'class.tslib_pibase.php');


/**
 * Plugin 'Font resizer' for the 'fontsizer' extension.
 *
 * @author	Jigal van Hemert <jigal@xs4all.nl>
 * @package	TYPO3
 * @subpackage	tx_fontsizer
 */
class tx_fontsizer_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_fontsizer_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_fontsizer_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'fontsizer';	// The extension key.
	/** @var	object	Instance of tslib_cObj */
	public $cObj;	//for use with userFunc call; will hold parent cObject
	
	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	string		The content that is displayed on the website
	 */
	function main($content, $conf) {
		$this->conf = $conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->pi_USER_INT_obj = 1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!

		//Check environment
		if (!isset($conf['templateCheck'])) {
			return $this->pi_wrapInBaseClass($this->pi_getLL('no_ts_template'));
		}

		$size = trim($GLOBALS['TSFE']->fe_user->getKey('ses', 'tx_fontsizer_size'));
		if (!$size) {
			$size = $this->conf['default'];
		}

		$content = '';
			//render smaller
		if ($this->conf['sizes.'][($size - 1) . '.']) {
			$lConf = $this->conf['sizes.'][($size - 1) . '.'];
		} else {
			$lConf = $this->conf['sizes.'][$size . '.'];
		}
		$content .= $this->cObj->stdWrap($this->cObj->cObjGetSingle($this->conf['items.']['smaller'], $this->conf['items.']['smaller.']), $lConf);

			//render default if option is set
		if ($this->conf['showDefault']) {
			$lConf = $this->conf['sizes.'][$this->conf['default'] . '.'];
			$content .= $this->cObj->stdWrap($this->cObj->cObjGetSingle($this->conf['items.']['default'], $this->conf['items.']['default.']), $lConf);
		}

			//render bigger
		if ($this->conf['sizes.'][($size + 1) . '.']) {
			$lConf = $this->conf['sizes.'][($size + 1) . '.'];
		} else {
			$lConf = $this->conf['sizes.'][$size . '.'];
		}
		$content .= $this->cObj->stdWrap($this->cObj->cObjGetSingle($this->conf['items.']['bigger'], $this->conf['items.']['bigger.']), $lConf);

		if (!$this->conf['noWrapInBaseClass']) {
			$content = $this->pi_wrapInBaseClass($content);
		}

		$GLOBALS['TSFE']->additionalHeaderData['tx_fontsizer'] = '<link rel="stylesheet" type="text/css" href="/index.php?eID=fontsizer" media="screen" />';

		return $content;
	}
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/fontsizer/pi1/class.tx_fontsizer_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/fontsizer/pi1/class.tx_fontsizer_pi1.php']);
}

?>